<script setup lang="ts">
import { ref, computed, watch, provide } from 'vue'
import { useReceiptStore } from '@/stores/receipt'
import ReceiptDialog from './ReceiptDialog.vue'
const receiptStore = useReceiptStore()

// Reactive variables
const receivedAmount = ref(receiptStore.receipt!.income)
const totalAmount = computed(() => {
  return receiptStore.receipt!.totalPrice - receiptStore.receipt!.promotionDiscount
})
const last = ref(receiptStore.receipt!.totalPrice - receiptStore.receipt!.promotionDiscount)

// Computed property for changeAmount
const changeAmount = computed(() => {
  const result = receivedAmount.value - totalToPay.value
  return result
})

function clearCash(): void {
  receivedAmount.value = 0
}

const totalToPay = computed(() => {
  return receiptStore.receipt!.totalPrice - receiptStore.receipt!.promotionDiscount
})

const dialogReceipt = ref(false)
provide('receiptDialog', dialogReceipt)
provide('changeAmount', changeAmount)

// Watch for changes in receivedAmount or totalAmount and update the changeAmount
watch([receivedAmount, totalAmount], () => {
  receiptStore.receipt!.change = changeAmount.value
  receiptStore.receipt!.income = receivedAmount.value
})
</script>

<template>
  <v-row>
    <v-dialog v-model="receiptStore.paymentTypeDialog" persistent width="800">
      <template v-slot:activator="{ props }">
        <v-col cols="6">
          <v-img src="/img/pos/เงินสด.png" contain lass="align-right" variant="plain" elevation="4" size="Medium" block
            style="box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1); border-radius: 8px; margin: auto" v-bind="props" @click="
      (receiptStore.selectPaymentOption = 'cash'),
      (dialogReceipt = true)"></v-img>
        </v-col>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">Payment</span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="4">
                <!-- ประเภทการจ่ายเงิน -->
                <v-text-field v-model="receivedAmount" label="Cash" variant="outlined"></v-text-field>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <!-- ราคาทั้งหมดที่ต้องจ่าย -->
                <v-text-field v-model="totalToPay" label="Total Pay" readonly variant="outlined"></v-text-field>
              </v-col>
              <v-col cols="12" sm="6" md="4">
                <!-- เงินทอน -->
                <v-text-field :value="changeAmount" label="Change" readonly variant="outlined"></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn variant="text" @click="() => {
      receiptStore.paymentTypeDialog = false
      clearCash()
    }
      ">
            กลับ
          </v-btn>
          <ReceiptDialog v-model:modelValue="dialogReceipt" :receipt="receiptStore.receipt!"
            :receiptItems="receiptStore.receiptItems" @save="() => {
      receiptStore.receiptOrder()
    }
      "></ReceiptDialog>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<style scoped>
.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
